unit QSort1;

interface

procedure QuickSort(
  var Target: array of Cardinal;
  StartIndex: Integer;
  EndIndex: Integer
);


implementation
uses Dialogs, SysUtils;

procedure QuickSort(var Target: array of Cardinal; StartIndex: Integer;
  EndIndex: Integer);
var
  ForwardIndex, BackwardIndex: Integer;
  Ref, Temp: Cardinal;

begin
  If StartIndex < EndIndex then
  begin
    //lƓւ
    Temp := Target[StartIndex + (EndIndex - StartIndex) div 2];
    Target[StartIndex + (EndIndex - StartIndex) div 2] := Target[StartIndex];
    Target[StartIndex] := Temp;
    
    Ref := Target[StartIndex];
    ForwardIndex := StartIndex;
    BackwardIndex := EndIndex + 1;

    while True do
    begin
      while ForwardIndex <= EndIndex do
      begin
        Inc(ForwardIndex);
        If Target[ForwardIndex] >= Ref then Break;
      end;

      while BackwardIndex >= StartIndex do
      begin
        Dec(BackwardIndex);
        If Target[BackwardIndex] <= Ref Then Break;
      end;

      If ForwardIndex >= BackwardIndex then Break;

      Temp := Target[ForwardIndex];
      Target[ForwardIndex] := Target[BackwardIndex];
      Target[BackwardIndex] := Temp;
    end;
    Target[StartIndex] := Target[BackwardIndex];
    Target[BackwardIndex] := Ref;

    QuickSort(Target, StartIndex, BackwardIndex - 1);
    QuickSort(Target, BackwardIndex + 1, EndIndex);
  end;
end;

end.
