unit UnitMSec;
interface
uses Windows, SysUtils;

function now_ms:TDateTime;
function TimeConvert(Mode: Integer; Data: Double): string;

implementation
uses Math;

var
  pcount:TLargeInteger;
  tick:TDateTime;

function now_ms;
var qq,yy:TLargeInteger;
    q:comp absolute qq;
    y:comp absolute yy;
    p:comp absolute pcount;
begin
   QueryPerformanceFrequency(qq);
   QueryPerformanceCounter(yy);
   Result:=tick+(y-p)/(24*3600*q);
end;

function TimeConvert(Mode: Integer; Data: Double): string;
var
  i, h, m, s, ms: Int64;
begin
  case Mode of
    0:begin
        i := Floor(24 * 60 * 60 * 1000 * Frac(Data));
        h := i div 3600000;
        m := (i mod 3600000) div 60000;
        s := (i mod 60000) div 1000;
        ms := i mod 1000;
        Result := Format('%d:%.2d:%.2d.%.3d', [h, m, s, ms]);
      end;

    1:begin
        i := Floor(24 * 60 * 60 * 1000 * Frac(Data));
        s := i div 1000;
        ms := i mod 1000;
        Result := Format('%d.%.3d', [s, ms]);
      end;
  end;
end;

initialization
  QueryPerformanceCounter(pcount);
  tick:=now;
end.

