unit frmSMenu;

interface
uses
  Windows, Messages, SysUtils, Variants, Classes,
  Graphics, Controls, Forms, Dialogs, StdCtrls,
  ExtCtrls;

type
  TFormStartMenu = class(TForm)
    RadioGroupMain: TRadioGroup;
    ButtonOK: TButton;
    ButtonCancel: TButton;
    procedure FormCreate(Sender: TObject);
    procedure ButtonCancelClick(Sender: TObject);
    procedure ButtonOKClick(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
    IsAllUser: Boolean;
    IsCancel: Boolean;
  end;

var
  FormStartMenu: TFormStartMenu;

implementation
{$R *.dfm}
uses hhUnit01;

procedure TFormStartMenu.FormCreate(Sender: TObject);
begin
  Caption := '̃X^[gj[H';
  BorderStyle := bsDialog;
  ButtonCancel.Caption := 'LZ';
  ButtonOK.Caption := 'OK';
  ButtonCancel.Cancel := True;
  ButtonOK.Default := True;
  BorderIcons := [];
  with RadioGroupMain do
  begin
    Font.Size := 12;
    Caption := 'ǂȂ̃X^[gj[ɒǉ܂H';
    Items.Add('[U[i' + hhGetUsername +
      'j̃X^[gj[');
    Items.Add('S[U[̃X^[gj[');
    ItemIndex := 0;
  end;
end;

procedure TFormStartMenu.ButtonCancelClick(Sender: TObject);
begin
  IsCancel := True;
  Close;
end;

procedure TFormStartMenu.ButtonOKClick(Sender: TObject);
begin
  if RadioGroupMain.ItemIndex = 0 then
    IsAllUser := False
  else
    IsAllUser := True;
  IsCancel := False;
  Close;
end;

end.
