﻿Public Class Form1
  Const RecordTime As Double = 1000 * 60 * 1
  Dim StartTime As Double = Environment.TickCount
  Dim UsedMemoryMax As Double = 0
  Dim UsedMemoryMin As Double = _
    My.Computer.Info.TotalPhysicalMemory
  Dim UsedMemorySum As Double = 0
  Dim DataCounter As Integer = 0
  Dim IsDone = False

  Private Sub Form1_Load(ByVal sender As System.Object, _
    ByVal e As System.EventArgs) Handles MyBase.Load
    Me.Text = "ViewMem 0.01"
    Timer1.Enabled = True
  End Sub

  Private Sub Timer1_Tick(ByVal sender As System.Object, _
    ByVal e As System.EventArgs) Handles Timer1.Tick
    Const formatString As String = "0.000GB"
    Dim f As Double
    Dim tc As Integer = Environment.TickCount

    f = (My.Computer.Info.TotalPhysicalMemory - _
      My.Computer.Info.AvailablePhysicalMemory) / (1024 ^ 3)
    If Not IsDone Then
      If tc < StartTime + RecordTime Then
        If f < UsedMemoryMin Then UsedMemoryMin = f
        If f > UsedMemoryMax Then UsedMemoryMax = f
        UsedMemorySum += f
        DataCounter += 1
        Dim ts = New TimeSpan(0, 0, 0, 0, tc - StartTime)
        TextBox1.Text = _
          "物理メモリー：" & Format( _
          My.Computer.Info.TotalPhysicalMemory / (1024 ^ 3), _
          formatString) & vbCrLf & _
          "使用メモリー：" & Format(f, formatString) & vbCrLf & _
          "最小使用メモリー：" & Format(UsedMemoryMin, _
          formatString) & vbCrLf & _
          "最大使用メモリー：" & Format(UsedMemoryMax, _
          formatString) & vbCrLf & _
          "平均使用メモリー：" & Format(UsedMemorySum / _
          DataCounter, formatString) & vbCrLf & _
          "経過時間：" & ts.ToString
      Else
        TextBox1.Text = _
          TextBox1.Text & vbCrLf & "記録を終了しました"
        Timer1.Enabled = False
        IsDone = True
      End If
    End If
  End Sub
End Class
