unit QSort2;

interface
uses Classes;

procedure QuickSort2(var Target: TList; StartIndex, EndIndex: Integer);

implementation
uses SysUtils;

procedure QuickSort2(var Target: TList; StartIndex, EndIndex: Integer);
var
  ForwardIndex, BackwardIndex: Integer;
  Ref, Temp: Cardinal;
  PCardinal1, PCardinal2: ^Cardinal;
begin
  If StartIndex < EndIndex then
  begin
    //lƓւ
    PCardinal1 := Target[StartIndex];
    PCardinal2 := Target[StartIndex + (EndIndex - StartIndex) div 2];
    Temp := PCardinal2^;
    PCardinal2^ := PCardinal1^;
    PCardinal1^ := Temp;

    //\[gJn
    Ref := PCardinal1^;
    ForwardIndex := StartIndex;
    BackwardIndex := EndIndex + 1;

    while True do
    begin
      while ForwardIndex <= EndIndex do
      begin
        Inc(ForwardIndex);
        PCardinal1 := Target[ForwardIndex];
        If PCardinal1^ >= Ref then Break;
      end;

      while BackwardIndex >= StartIndex do
      begin
        Dec(BackwardIndex);
        PCardinal1 := Target[BackwardIndex];
        If PCardinal1^ <= Ref Then Break;
      end;

      If ForwardIndex >= BackwardIndex then Break;

      PCardinal1 := Target[ForwardIndex];
      Temp := PCardinal1^;
      PCardinal2 := Target[BackwardIndex];
      PCardinal1^ := PCardinal2^;
      PCardinal2^ := Temp;
    end;
    PCardinal1 := Target[StartIndex];
    PCardinal2 := Target[BackwardIndex];

    PCardinal1^ := PCardinal2^;
    PCardinal2^ := Ref;

    QuickSort2(Target, StartIndex, BackwardIndex - 1);
    QuickSort2(Target, BackwardIndex + 1, EndIndex);
  end;
end;

end.
